// Pencil drawing script by Vadim647
// <Contest entry>
// The idea is to store images in mdl files and emit pencil drawing on screen.
// I made it using pairs of vertex in mdl. It part by part loads vertex positions and draws line of
// small panels between them to make a look of pencil drawing.

#include <acknex.h>
#include <default.c>
#define nv nullvector
// Not to cut the code, I just hate typing 'nullvector' every time.
TEXT* pic_refs = {string("pic1.mdl","pic2.mdl","pic3.mdl","pic5.mdl","pic4.mdl","pic6.mdl");}	//array stores drawing's names
var pic_speeds[10] = {1,2,2,4,2,3};									//&^ linked: drawing speed
#define g_s_m 1
var killshape;					//when on, drawed shape disappears
BMAP* b1 = "b3.png";			//brush\pencil picture
#define pen_half_w 2
#define pen_half_h 2
//^ 2 vars to make editing easier. (centers of pen bmap).
var v;							//temp variable 1
var i;							//temp variable 2
var inter[4] = { 0, 1, 3, 0};	//drawn_parts,parts_to_wait,distance_between_parts,currentShapeIndex
STRING* t_s="#120";				//temp string
VECTOR t_v;						//temp vector 1
VECTOR t_v2;					//temp vector 2
BMAP* paper = "paper1.png";		//picture refence (photo)
ENTITY* shape;					//shape

PANEL* tablet = 				//background panel
{
	bmap = paper;
	flags = VISIBLE;
}
function minipanel(x,y)			//function to create 'dot'
{
	PANEL* mpanel;				//define a new panel
	var i9;						//angle of new panel
	i9 = integer(random(360));	//make it random, to make lines unique
	str_cpy(t_s,"bmap = b1;");	//store panel definition script in string
	str_cat_num(t_s,"pos_x = %.0f;",x + ( - cosv(i9) + cosv(i9 - 90) ) * pen_half_w );
	str_cat_num(t_s,"pos_y = %.0f;",y + ( - sinv(i9) + sinv(i9 - 90) ) * -pen_half_h );
	//How hard and how stupid is algoritm of centered images...
	str_cat_num(t_s,"angle = %.0f;",i9+90);//rotate panel
	str_cat(t_s,"flags = VISIBLE;");//and final part of definition
	mpanel = pan_create(t_s,3);		//now create a panel using definition
	while (!(killshape)) {wait(1);}	//wait until shape killing var is activated
	pan_remove(mpanel);				//remove panel after it.
}
function shapeloop()				//loop to draw shape after shape until it's last.
{
	inter[3] = 0;						//set shape index to 0 (first shape)
	while (inter[3] < pic_refs.strings)	
	{
		ent_morph(shape,(pic_refs.pstring)[inter[3]]);	//morph to new shape
		inter[1] = pic_speeds[inter[3]] * g_s_m;		//set drawing speed
		v = 1;							//set vert. counter to 1 (first vertex)
		while (v < ent_vertices(shape))	//while there's more vertex
		{
			vec_for_vertex(t_v,shape,v);	//locate vertex #v
			vec_for_vertex(t_v2,shape,v+1);	//locate vertex #v+1 (next one)
			i = 0;							//set second temp to 0
			while (i < vec_dist(t_v,t_v2))	//while line between positions isn't finished
			{	//create a mini-panel at related point between temp's
				minipanel(t_v.x + (t_v2.x-t_v.x)*(i/vec_dist(t_v,t_v2)),-t_v.y - (t_v2.y-t_v.y)*(i/vec_dist(t_v,t_v2)));
				i += inter[2];				//increase position by stored var
				inter[0] += 1;				//increase drawn panels count
				if (inter[0] >= inter[1])	//if it's larger then drawing speed,
				{
					inter[0] -= inter[1];	//reduce count by d-speed and wait one frame.
					wait(1);	//It allows control over drawing speed.
				}
			}
			v += 2;//increase v by 2 (next 2 vertex)
		}
		if (inter[3] < pic_refs.strings - 1) wait(-3);		//wait 3 seconds (allow user to take snapshot)
		if (inter[3] < pic_refs.strings - 1) killshape = 1;	//activate killshape var
		wait(-0.5);		//0.5 seconds to watch clear paper
		killshape = 0;	//deactivate killshape to allow drawing again
		inter[3] += 1;	//increase shape index
	}
	while (1) {draw_text("Created by Vadim647. <100 lines> contest entry.
	Sorry for small drawings count, I made it in 2 days :)",4,4,nv);wait(1);}
}

function main()
{
	video_switch(8,0,1);					//1024x768x32xFullScreen
	vec_set(sky_color,vector(224,224,224));	//why I need background...?
	level_load(NULL);	//null level
	wait(3);			//waste of one semicolon
	camera.arc = 90;	//to allow drawing of shape itself (if someone will use this script)
	media_loop("sound6.mp3",NULL,100);	//background sound. Makes a part of game
	vec_set(camera.x,vector(0,0,256));		//again, for shape drawing,
	vec_set(camera.pan,vector(90,-90,0));	//but isn't used now.
	shape = ent_create("earth.mdl",nullvector,NULL);//create shape object
	set(shape,INVISIBLE);//make it invisible
	draw_textmode("Arial",0,24,100);
	shapeloop();		//and activate loop.
}